"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var mixins_1 = tslib_1.__importDefault(require("../utils/mixins"));
var BaseDisplayFieldRender_1 = tslib_1.__importDefault(require("./BaseDisplayFieldRender"));
var InputComponentPropsMixin_1 = tslib_1.__importDefault(require("../mixins/InputComponentPropsMixin"));
exports.default = mixins_1.default(BaseDisplayFieldRender_1.default, InputComponentPropsMixin_1.default).extend({
    name: 'BaseInputFieldRender',
    computed: {
        inputProps: function () {
            return {
                disabled: this.disabled,
                readonly: this.readonly
            };
        }
    },
    watch: {
        inputProps: function () {
            this.setResolveRenderData();
        }
    },
    methods: {
        resolveRenderData: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    return [2 /*return*/, this.field.prepareInputRender(this.inputProps, this.renderProps)];
                });
            });
        },
        renderField: function (h) {
            return this.field.inputRender(h, this.renderData);
        }
    }
});
