"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var mixins_1 = tslib_1.__importDefault(require("../utils/mixins"));
var FieldPropsMixin_1 = tslib_1.__importDefault(require("./FieldPropsMixin"));
var LoadingSlotMixin_1 = tslib_1.__importDefault(require("./LoadingSlotMixin"));
var ConfigHandler_1 = require("../utils/ConfigHandler");
/**
 * Main component to display value of a field
 */
exports.default = mixins_1.default(LoadingSlotMixin_1.default, FieldPropsMixin_1.default).extend({
    name: 'DisplayField',
    inheritAttrs: false,
    data: function () { return ({
        displayComponent: null
    }); },
    asyncComputed: {
        displayComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    ConfigHandler_1.configHandler.checkWarningUseAsyncComputed();
                    return [2 /*return*/, this.resolveDisplayComponent()];
                });
            });
        }
    },
    watch: {
        fieldObj: function () {
            this.setResolveDisplayComponent();
        }
    },
    created: function () {
        this.setResolveDisplayComponent();
    },
    methods: {
        setResolveDisplayComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var _a;
                return tslib_1.__generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!!ConfigHandler_1.configHandler.useAsyncComputed()) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, this.resolveDisplayComponent()];
                        case 1:
                            _a.displayComponent = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        },
        resolveDisplayComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var componentModule;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.fieldObj) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.fieldObj.displayComponent];
                        case 1:
                            componentModule = _a.sent();
                            return [2 /*return*/, componentModule.default];
                        case 2: return [2 /*return*/, null];
                    }
                });
            });
        }
    },
    render: function (h) {
        if (this.displayComponent && this.fieldObj) {
            return h(this.displayComponent, {
                props: {
                    field: this.fieldObj,
                    renderProps: this.renderProps
                }
            });
        }
        else {
            return this.renderLoading(h);
        }
    }
});
