"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var mixins_1 = tslib_1.__importDefault(require("../utils/mixins"));
var FieldPropsMixin_1 = tslib_1.__importDefault(require("./FieldPropsMixin"));
var LoadingSlotMixin_1 = tslib_1.__importDefault(require("./LoadingSlotMixin"));
var ConfigHandler_1 = require("../utils/ConfigHandler");
/**
 * Main component to display value of a field
 */
exports.default = mixins_1.default(LoadingSlotMixin_1.default, FieldPropsMixin_1.default).extend({
    name: 'InputField',
    inheritAttrs: false,
    props: {
        disabled: {
            type: Boolean,
            default: false
        },
        readonly: {
            type: Boolean,
            default: false
        }
    },
    data: function () { return ({
        inputComponent: null
    }); },
    asyncComputed: {
        inputComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    ConfigHandler_1.configHandler.checkWarningUseAsyncComputed();
                    return [2 /*return*/, this.resolveInputComponent()];
                });
            });
        }
    },
    watch: {
        fieldObj: function () {
            this.setResolveInputComponent();
        }
    },
    created: function () {
        this.setResolveInputComponent();
    },
    methods: {
        setResolveInputComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var _a;
                return tslib_1.__generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!!ConfigHandler_1.configHandler.useAsyncComputed()) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, this.resolveInputComponent()];
                        case 1:
                            _a.inputComponent = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        },
        resolveInputComponent: function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                var componentModule;
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.fieldObj) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.fieldObj.inputComponent];
                        case 1:
                            componentModule = _a.sent();
                            return [2 /*return*/, componentModule.default];
                        case 2: return [2 /*return*/, null];
                    }
                });
            });
        }
    },
    render: function (h) {
        if (this.inputComponent && this.fieldObj) {
            return h(this.inputComponent, {
                props: {
                    field: this.fieldObj,
                    renderProps: this.renderProps,
                    disabled: this.disabled,
                    readonly: this.readonly
                }
            });
        }
        else {
            return this.renderLoading(h);
        }
    }
});
