import { Response } from '../types/models/ModelManager';
import { BaseException } from './BaseException';
export declare class APIException extends BaseException {
    static readonly statusCode: number;
    private _response;
    constructor(response: Response, message?: string);
    get response(): Response;
}
/**
 * 400 Bad request
 */
export declare class BadRequestAPIException extends APIException {
    static readonly statusCode: number;
    constructor(response: Response, message?: string);
}
/**
 * 401 Unauthorized
 */
export declare class UnauthorizedAPIException extends APIException {
    static readonly statusCode: number;
    constructor(response: Response, message?: string);
}
/**
 * 403 Forbidden
 */
export declare class ForbiddenAPIException extends APIException {
    static readonly statusCode: number;
    constructor(response: Response, message?: string);
}
/**
 * 404 Not found
 */
export declare class NotFoundAPIException extends APIException {
    static readonly statusCode: number;
    constructor(response: Response, message?: string);
}
/**
 * 500 Internal Server Error
 */
export declare class InternalServerErrorAPIException extends APIException {
    static readonly statusCode: number;
    constructor(response: Response, message?: string);
}
