"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalServerErrorAPIException = exports.NotFoundAPIException = exports.ForbiddenAPIException = exports.UnauthorizedAPIException = exports.BadRequestAPIException = exports.APIException = void 0;
var tslib_1 = require("tslib");
var BaseException_1 = require("./BaseException");
var APIException = /** @class */ (function (_super) {
    tslib_1.__extends(APIException, _super);
    function APIException(response, message) {
        if (message === void 0) { message = 'Unhandled APIException'; }
        var _this = _super.call(this, message) || this;
        _this.constructor = APIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = APIException.prototype;
        _this._response = response;
        return _this;
    }
    Object.defineProperty(APIException.prototype, "response", {
        get: function () {
            return this._response;
        },
        enumerable: false,
        configurable: true
    });
    return APIException;
}(BaseException_1.BaseException));
exports.APIException = APIException;
/**
 * 400 Bad request
 */
var BadRequestAPIException = /** @class */ (function (_super) {
    tslib_1.__extends(BadRequestAPIException, _super);
    function BadRequestAPIException(response, message) {
        if (message === void 0) { message = 'Bad Request'; }
        var _this = _super.call(this, response, message) || this;
        _this.constructor = BadRequestAPIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = BadRequestAPIException.prototype;
        return _this;
    }
    BadRequestAPIException.statusCode = 400;
    return BadRequestAPIException;
}(APIException));
exports.BadRequestAPIException = BadRequestAPIException;
/**
 * 401 Unauthorized
 */
var UnauthorizedAPIException = /** @class */ (function (_super) {
    tslib_1.__extends(UnauthorizedAPIException, _super);
    function UnauthorizedAPIException(response, message) {
        if (message === void 0) { message = 'Unauthorized'; }
        var _this = _super.call(this, response, message) || this;
        _this.constructor = UnauthorizedAPIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = UnauthorizedAPIException.prototype;
        return _this;
    }
    UnauthorizedAPIException.statusCode = 401;
    return UnauthorizedAPIException;
}(APIException));
exports.UnauthorizedAPIException = UnauthorizedAPIException;
/**
 * 403 Forbidden
 */
var ForbiddenAPIException = /** @class */ (function (_super) {
    tslib_1.__extends(ForbiddenAPIException, _super);
    function ForbiddenAPIException(response, message) {
        if (message === void 0) { message = 'Forbidden'; }
        var _this = _super.call(this, response, message) || this;
        _this.constructor = ForbiddenAPIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = ForbiddenAPIException.prototype;
        return _this;
    }
    ForbiddenAPIException.statusCode = 403;
    return ForbiddenAPIException;
}(APIException));
exports.ForbiddenAPIException = ForbiddenAPIException;
/**
 * 404 Not found
 */
var NotFoundAPIException = /** @class */ (function (_super) {
    tslib_1.__extends(NotFoundAPIException, _super);
    function NotFoundAPIException(response, message) {
        if (message === void 0) { message = 'Not Found'; }
        var _this = _super.call(this, response, message) || this;
        _this.constructor = NotFoundAPIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = NotFoundAPIException.prototype;
        return _this;
    }
    NotFoundAPIException.statusCode = 404;
    return NotFoundAPIException;
}(APIException));
exports.NotFoundAPIException = NotFoundAPIException;
/**
 * 500 Internal Server Error
 */
var InternalServerErrorAPIException = /** @class */ (function (_super) {
    tslib_1.__extends(InternalServerErrorAPIException, _super);
    function InternalServerErrorAPIException(response, message) {
        if (message === void 0) { message = 'Internal Server Error'; }
        var _this = _super.call(this, response, message) || this;
        _this.constructor = InternalServerErrorAPIException;
        // @ts-ignore
        // eslint-disable-next-line no-proto
        _this.__proto__ = InternalServerErrorAPIException.prototype;
        return _this;
    }
    InternalServerErrorAPIException.statusCode = 500;
    return InternalServerErrorAPIException;
}(APIException));
exports.InternalServerErrorAPIException = InternalServerErrorAPIException;
