import { FormatStringField } from './FormatStringField';
import { CreateElement, VNode } from 'vue';
import { InputRenderData } from '../types/fields/Field';
export declare class BooleanField extends FormatStringField {
    /**
     * Format boolean value to string
     */
    valueFormatter(): Promise<string | null>;
    /**
     * Parse value and convert to boolean
     */
    valueParser(rawValue: any): Promise<boolean>;
    /**
     * Simple Vue render function when using default inputComponent for input of field value with <input-field/>
     */
    inputRender(h: CreateElement, { value, inputProps }: InputRenderData): VNode;
}
