"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanField = void 0;
var tslib_1 = require("tslib");
var FormatStringField_1 = require("./FormatStringField");
var ConfigHandler_1 = require("../utils/ConfigHandler");
var BooleanField = /** @class */ (function (_super) {
    tslib_1.__extends(BooleanField, _super);
    function BooleanField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Format boolean value to string
     */
    BooleanField.prototype.valueFormatter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var value;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.value];
                    case 1:
                        value = _a.sent();
                        return [2 /*return*/, value ? ConfigHandler_1.configHandler.getTranslation('yes') : ConfigHandler_1.configHandler.getTranslation('no')];
                }
            });
        });
    };
    /**
     * Parse value and convert to boolean
     */
    BooleanField.prototype.valueParser = function (rawValue) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, Boolean(rawValue)];
            });
        });
    };
    /**
     * Simple Vue render function when using default inputComponent for input of field value with <input-field/>
     */
    BooleanField.prototype.inputRender = function (h, _a) {
        var _this = this;
        var value = _a.value, inputProps = _a.inputProps;
        var disabled = inputProps.disabled, readonly = inputProps.readonly;
        return h('input', {
            attrs: {
                type: 'checkbox',
                checked: Boolean(value),
                disabled: disabled
            },
            on: {
                click: function (event) {
                    if (readonly) {
                        event.preventDefault();
                    }
                },
                change: function (event) {
                    var target = event.target;
                    _this.setParseValue(target.checked);
                }
            }
        });
    };
    return BooleanField;
}(FormatStringField_1.FormatStringField));
exports.BooleanField = BooleanField;
