import { FormatStringField } from './FormatStringField';
import { FieldTypeOptions, InputProps } from '../types/fields/Field';
import { CreateElement, VNode } from 'vue';
export interface DecimalFieldOptions extends FieldTypeOptions {
    decimalPlaces: number;
}
export interface DecimalFieldInputRenderData {
    value: any;
    decimalPlaces: number;
    inputProps: InputProps;
}
export declare class DecimalField extends FormatStringField {
    /**
     * Validate field options
     */
    protected validateOptions(options: DecimalFieldOptions): Promise<DecimalFieldOptions>;
    /**
     * Prepare data for input render
     */
    prepareInputRender(inputProps: InputProps): Promise<DecimalFieldInputRenderData>;
    inputRender(h: CreateElement, { value, decimalPlaces, inputProps }: DecimalFieldInputRenderData): VNode;
    /**
     * Parse value and convert to number or null
     */
    valueParser(rawValue: any): Promise<number | null>;
}
