"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntegerField = void 0;
var tslib_1 = require("tslib");
var common_1 = require("../utils/common");
var FormatStringField_1 = require("./FormatStringField");
var IntegerField = /** @class */ (function (_super) {
    tslib_1.__extends(IntegerField, _super);
    function IntegerField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Simple Vue render function when using default inputComponent for input of field value with <input-field/>
     */
    IntegerField.prototype.inputRender = function (h, _a) {
        var _this = this;
        var value = _a.value, inputProps = _a.inputProps;
        var disabled = inputProps.disabled, readonly = inputProps.readonly;
        return h('input', {
            attrs: {
                type: 'number',
                value: value,
                disabled: disabled,
                readonly: readonly
            },
            on: {
                input: function (event) {
                    var target = event.target;
                    _this.setParseValue(target.value);
                }
            }
        });
    };
    /**
     * Parse value and convert to number or null
     */
    IntegerField.prototype.valueParser = function (rawValue) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, common_1.isNull(rawValue) ? null : parseInt(rawValue)];
            });
        });
    };
    return IntegerField;
}(FormatStringField_1.FormatStringField));
exports.IntegerField = IntegerField;
